【Revit 二次开发】获取所有房间的角点

获取所有房间的角点:

     public List<XYZ> getRoomXYZandV(Element room, Document doc)
        {
            List<XYZ> listXYZ = new List<XYZ>();

            XYZ roomLocationXyz = room.Location == null ? new XYZ(0, 0, 0) : (room.Location as LocationPoint).Point;
            //房间中心点坐标
            FilteredElementCollector col = null;
            col = new FilteredElementCollector(doc).OfClass(typeof(SpatialElement));
            // 定义边界设置
            SpatialElementBoundaryOptions opt = new SpatialElementBoundaryOptions();

            opt.StoreFreeBoundaryFaces = true;
            opt.SpatialElementBoundaryLocation = SpatialElementBoundaryLocation.Finish; // 闭合线
            //opt.SpatialElementBoundaryLocation = SpatialElementBoundaryLocation.Finish; //非闭合线
            IList<IList<BoundarySegment>> segments = (room as Room).GetBoundarySegments(opt);
            if (null != segments)
            {
                foreach (IList<BoundarySegment> segmentList in segments)
                {
                    foreach (BoundarySegment boundarySegment in segmentList)
                    {
                        List<Curve> allCurves = new List<Curve>();
                        allCurves.Add(boundarySegment.GetCurve());
                        XYZ start = boundarySegment.GetCurve().GetEndPoint(0);
                        XYZ end = boundarySegment.GetCurve().GetEndPoint(1);
                        listXYZ.Add(start);
                        listXYZ.Add(end);
                    }
                }
            }

 

            if (listXYZ.Count == 0)
            {
                listXYZ.Add(new XYZ(0, 0, 0));
                return listXYZ;
            }
            else
            {
                // MessageBox.Show("get xyzs");
                return listXYZ; //房间边界线所有的端点 

            }
        }

 

获取房间所有边界:

  public List<Curve> GetRoomCurveList(Element room, Document doc)
        {
           // List<XYZ> listXYZ = new List<XYZ>();
            List<Curve> allCurves = new List<Curve>();
            XYZ roomLocationXyz = room.Location == null ? new XYZ(0, 0, 0) : (room.Location as LocationPoint).Point;
            //房间中心点坐标
            FilteredElementCollector col = null;
            col = new FilteredElementCollector(doc).OfClass(typeof(SpatialElement));
            // 定义边界设置
            SpatialElementBoundaryOptions opt = new SpatialElementBoundaryOptions();
            opt.StoreFreeBoundaryFaces = true;
            opt.SpatialElementBoundaryLocation = SpatialElementBoundaryLocation.Center; // 闭合线
            //opt.SpatialElementBoundaryLocation = SpatialElementBoundaryLocation.Finish; // 非闭合线
            IList<IList<BoundarySegment>> segments = (room as Room).GetBoundarySegments(opt);
            if (null != segments)
            {
                foreach (IList<BoundarySegment> segmentList in segments)
                {
                    foreach (BoundarySegment boundarySegment in segmentList)
                    {
                       
                        allCurves.Add(boundarySegment.GetCurve());
                       // XYZ start = boundarySegment.GetCurve().GetEndPoint(0);
                       // XYZ end = boundarySegment.GetCurve().GetEndPoint(1);
                       // listXYZ.Add(start);
                       // listXYZ.Add(end);
                    }
                }
            }
            return allCurves;
        }

 

  • 1
    点赞
  • 10
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值